Subject: [bug#65935] [PATCH] gnu: Add ngn-k.

From: "B. Wilson" <[email-masked]>
Date: Fri, 20 Oct 2023 17:06:15 +0200

> This package cannot be included in Guix because what we have above is
> not source code: it’s deliberately obfuscated code, it’s not “the
> preferred form of the work for making modifications to it” (as the GPL
> puts it) in any way.
> 
> I hope that makes sense.

I agree that it's super weird, but it's not obfuscated code. Rather, it's the
famously terse Arthur Whitney style. The APL/J/K family of array-oriented
languages all famously have implementations strongly influenced by Whitney, and
ngn-k is just following in that tradition. Those with the relevant domain
knowledge tend to agree that the code is pretty readable.

If you want other examples, see

- Whitney's B interpreter: https://github.com/tlack/b-decoded
- Jsoftware's J interpreter: https://github.com/jsoftware/jsource

The latter is both GPL-3 and actively maintained.